<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plait Webview Docs Source: control/control.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plait Webview Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="namespaces.list.html" class="dropdown-toggle" data-toggle="dropdown">Namespaces<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="socket.html">socket</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="Control.html">Control</a></li><li><a href="SessionControl.html">SessionControl</a></li><li><a href="Collection.html">Collection</a></li><li><a href="Overview.html">Overview</a></li><li><a href="Plugins.html">Plugins</a></li><li><a href="Editor.html">Editor</a></li><li><a href="FileMenu.html">FileMenu</a></li><li><a href="Form.html">Form</a></li><li><a href="Routing.html">Routing</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="global.html" class="dropdown-toggle" data-toggle="dropdown">Global<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="global.html#routing">routing</a></li><li><a href="global.html#control">control</a></li><li><a href="global.html#showSessions">showSessions</a></li><li><a href="global.html#TabButton">TabButton</a></li><li><a href="global.html#CueButton">CueButton</a></li><li><a href="global.html#CueBar">CueBar</a></li><li><a href="global.html#form">form</a></li><li><a href="global.html#editor">editor</a></li><li><a href="global.html#addGame">addGame</a></li><li><a href="global.html#createGame">createGame</a></li><li><a href="global.html#removeGame">removeGame</a></li><li><a href="global.html#inputPrompt">inputPrompt</a></li><li><a href="global.html#confirmation">confirmation</a></li><li><a href="global.html#identifyBrowser">identifyBrowser</a></li><li><a href="global.html#generateUUID">generateUUID</a></li><li><a href="global.html#namespace">namespace</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: control/control.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/**  
 * @file control
 * @copyright Lasse Marburg 2020
 * @license GPLv3 
 */

//const Swal = swal;
control = {collections:{},document_ready:false}

socket.on('connect', function(data){
  console.log("control connected")

  socket.get('game','name')
	.then(function(title) {
		$("#title").text(title + " control")
    document.title = title + " control"
    
    main = control
    control.game = title
    
    $('#home').parent().attr("href","/ui", "_self")
    $('#editor').parent().attr("href","/ui/" + title + "/editor", "_self")
    
    /** url routing instance 
    * @global */
    routing = new Routing("/ui/"+ title + "/control")
    
    control.init()

    control.collections.sessions = new Sessions()
    control.collections.sessions.update()
    .then(result => {
      while(!control.document_ready) {}
      
      routing.review()
    })
    .catch(error => {
      console.error(error)
    })
	})
  
  //showSessions()
})

$( document ).ready(function() {
  console.log("ready")
  control.document_ready = true
})

/**
* contorl interface container
*/
class Control {
  constructor() {
    this.collections = {}
    this.document_ready = false
  }
  
  /**
  * detach all elements from content DOM
  */
  clearContent() {
    $('#editor_div').children().detach()
    $('#content').html($('#editor_div'))
  }

  /**
   * on socket connect.  
   * clean up navbar/remove elements
   */
  init() {
    $(".collection_menu").remove()
  }
}

/** control instance 
* @global */
control = new Control()

/**
* archive function. Check it out one last time then remove it
* @todo: REMOVE
* @deprecated
*/
function showSessions() {
  console.log("overview")
  $('#content').html($(''))
  
  $('#content').prepend($('&lt;h2>Active Sessions&lt;/h2>'))
  
  let $sessions = $('&lt;table class="collection_list">&lt;th>ID&lt;/th>&lt;th>Level&lt;/th>&lt;th>Player&lt;/th>&lt;th>Slot&lt;/th>&lt;th>Cue&lt;/th>&lt;th>Since&lt;/th>&lt;th>&lt;/th>&lt;th>&lt;/th>&lt;/table>')
  
  $sessions.appendTo('#content')
  var player = []
  socket.get('find', {'player':{}})
  .then(result => {
    player = result
    return socket.get('find', {'sessions':{}})
  })
  .then(result => {
    console.log(result)
    if(result.length) {
      for(let session of result) {
        let s_player = ""
        for(let plyr of player) {
          if(plyr.hasOwnProperty('sessions')) {
            if(plyr.sessions.length) {
              for(let p_session of plyr.sessions) {
                if(p_session._id == session._id) {
                  s_player += plyr.name + " " + plyr.telnumber
                  var timeslot = plyr.timeslot
                }
              }
            }
          }
        }
        let cues = ""
        for(let k in session) {
          if(session[k]) {
            if(session[k].hasOwnProperty('date')) {
              cues = k + " (" + Math.round((new Date(Date.now() - new Date(session[k].date)))/60000) + " min.) "
            } else if(session[k].hasOwnProperty('smsin')) {
              if(session[k].smsin.hasOwnProperty('match')) {
                cues = k + " ('" + session[k].smsin.match + "')"
              } else {
                cues = k + " ('" + session[k].smsin.text.substring(0, 32) + "')"
              }
            } else if(session[k].hasOwnProperty('logic')) {
              cues = k + " (" + session[k].logic.match + ")"
            }
          }
        }
        //&lt;i class="far fa-times-circle">&lt;/i>
        let $del = $('&lt;td class="icon">&lt;i class="fa fa-times tableIcon">&lt;/i>&lt;/td>')
        $del.on('click', e => {
          confirmation("Are you sure you want to cancel session " + session._id + " based on level " + session.level)
          .then(result => {
            if(result) {
              socket.get('session', {cmd:'delete',session:{_id:session._id}})
              showSessions()
            }
          })
          .catch(error => {
            log.error(this.name, error)
          })
        })
        
        $('&lt;tr id="' + session._id + '">&lt;td>' + session._id + '&lt;/td>&lt;td>' + session.level + '&lt;/td>&lt;td>' + s_player + '&lt;/td>&lt;td>' + timeslot + '&lt;/td>&lt;td>' + cues + '&lt;/td>&lt;td>' + Math.round((new Date(Date.now() - new Date(session.date)))/60000) + ' min.&lt;/td>&lt;td class="icon">&lt;a href="' + session.name + '#list_view">&lt;i class="fa fa-play-circle tableIcon">&lt;/i>&lt;/a>&lt;/td>&lt;/tr>').appendTo($sessions)
        $('#' + session._id).append($del)
      }
    }
  })
}
</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/'>Plaiframe Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/plugins/'>Plugin Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
